searchNodes=[{"ref":"Libp2p.html","title":"Libp2p","type":"module","doc":"Libp2p OTP Application that communicates with the libp2p daemon over UNIX domain socket using Protobuf. Socket path is configured in config.exs. Libp2p API is exposed in the DHT, PubSub, ConnManager and Peer modules. Installation If available in Hex, the package can be installed by adding libp2p to your list of dependencies in mix.exs: def deps do [ {:libp2p, &quot;~&gt; 0.1.0&quot;} ] end Documentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/libp2p."},{"ref":"Libp2p.html#start/2","title":"Libp2p.start/2","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (e.g., mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"Libp2p.ConnectionManager.html","title":"Libp2p.ConnectionManager","type":"module","doc":"Functions to handle open connections such as tagging and trimming."},{"ref":"Libp2p.ConnectionManager.html#tag_peer/3","title":"Libp2p.ConnectionManager.tag_peer/3","type":"function","doc":"Tag a peer with a label and weight."},{"ref":"Libp2p.ConnectionManager.html#trim/0","title":"Libp2p.ConnectionManager.trim/0","type":"function","doc":"Clients can issue a TRIM request to trim open connections."},{"ref":"Libp2p.ConnectionManager.html#untag_peer/2","title":"Libp2p.ConnectionManager.untag_peer/2","type":"function","doc":"Remove tag from a peer."},{"ref":"Libp2p.DHT.html","title":"Libp2p.DHT","type":"module","doc":"Functions for interacting with the Libp2p destributed hashtable."},{"ref":"Libp2p.DHT.html#find_peer/1","title":"Libp2p.DHT.find_peer/1","type":"function","doc":"Clients can issue a FIND_PEER request to query the DHT for a given peer&#39;s known addresses."},{"ref":"Libp2p.DHT.html#find_peers_connected_to/1","title":"Libp2p.DHT.find_peers_connected_to/1","type":"function","doc":"Clients can issue a FIND_PEERS_CONNECTED_TO_PEER request to query the DHT for peers directly connected to a given peer in the DHT."},{"ref":"Libp2p.DHT.html#find_providers/2","title":"Libp2p.DHT.find_providers/2","type":"function","doc":"Clients can issue a FIND_PROVIDERS request to query the DHT for peers that have a piece of content, identified by a CID. FIND_PROVIDERS optionally include a count, specifying a maximum number of results to return."},{"ref":"Libp2p.DHT.html#get_closest_peers/1","title":"Libp2p.DHT.get_closest_peers/1","type":"function","doc":"Clients can issue a GET_CLOSEST_PEERS request to query the DHT routing table for peers that are closest to a provided key."},{"ref":"Libp2p.DHT.html#get_public_key/1","title":"Libp2p.DHT.get_public_key/1","type":"function","doc":"Clients can issue a GET_PUBLIC_KEY request to query the DHT routing table for a given peer&#39;s public key."},{"ref":"Libp2p.DHT.html#get_value/1","title":"Libp2p.DHT.get_value/1","type":"function","doc":"Clients can issue a GET_VALUE request to query the DHT for a value stored at a key in the DHT."},{"ref":"Libp2p.DHT.html#provide/1","title":"Libp2p.DHT.provide/1","type":"function","doc":"Clients can issue a PROVIDE request to announce that they have data addressed by a given CID."},{"ref":"Libp2p.DHT.html#put_value/2","title":"Libp2p.DHT.put_value/2","type":"function","doc":"Clients can issue a PUT_VALUE request to write a value to a key in the DHT."},{"ref":"Libp2p.DHT.html#search_value/1","title":"Libp2p.DHT.search_value/1","type":"function","doc":"Clients can issue a SEARCH_VALUE request to query the DHT for the best/most valid value stored at a given key. It will return a stream of values, terminating on the best/most valid value found. After the daemon finishes its query, it will update any peers in the DHT that returned stale or bad data for the given key with the better record."},{"ref":"Libp2p.IpcClient.html","title":"Libp2p.IpcClient","type":"module","doc":"Dispatches calls to the IpcServer."},{"ref":"Libp2p.IpcClient.html#post_request/1","title":"Libp2p.IpcClient.post_request/1","type":"function","doc":""},{"ref":"Libp2p.IpcServer.html","title":"Libp2p.IpcServer","type":"module","doc":""},{"ref":"Libp2p.IpcServer.html#child_spec/1","title":"Libp2p.IpcServer.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Libp2p.IpcServer.html#init/1","title":"Libp2p.IpcServer.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Libp2p.IpcServer.html#post/2","title":"Libp2p.IpcServer.post/2","type":"function","doc":""},{"ref":"Libp2p.IpcServer.html#start_link/1","title":"Libp2p.IpcServer.start_link/1","type":"function","doc":""},{"ref":"Libp2p.Peer.html","title":"Libp2p.Peer","type":"module","doc":"Functions related to peer connection and streaming."},{"ref":"Libp2p.Peer.html#connect/3","title":"Libp2p.Peer.connect/3","type":"function","doc":"Clients issue a Connect request when they wish to connect to a known peer on a given set of addresses."},{"ref":"Libp2p.Peer.html#disconnect/1","title":"Libp2p.Peer.disconnect/1","type":"function","doc":"Clients issue a Disconnect request when they wish to disconnect from a peer."},{"ref":"Libp2p.Peer.html#from_string/1","title":"Libp2p.Peer.from_string/1","type":"function","doc":"Turns peer id into a binary representation."},{"ref":"Libp2p.Peer.html#identify/0","title":"Libp2p.Peer.identify/0","type":"function","doc":"Clients issue an Identify request when they wish to determine the peer ID and listen addresses of the daemon."},{"ref":"Libp2p.Peer.html#list_peers/0","title":"Libp2p.Peer.list_peers/0","type":"function","doc":"List all peers that the daemon is connected to."},{"ref":"Libp2p.Peer.html#to_string/1","title":"Libp2p.Peer.to_string/1","type":"function","doc":"Turns peer id binary to string representation."},{"ref":"Libp2p.PubSub.html","title":"Libp2p.PubSub","type":"module","doc":"The libp2p daemon PubSub protocol allows clients to subscribe and publish to topics using libp2p PubSub."},{"ref":"Libp2p.PubSub.html#get_topics/0","title":"Libp2p.PubSub.get_topics/0","type":"function","doc":"Clients can issue a GET_TOPICS request to get a list of topics the node is subscribed to."},{"ref":"Libp2p.PubSub.html#list_peers/0","title":"Libp2p.PubSub.list_peers/0","type":"function","doc":"Clients can issue a LIST_PEERS request to get a list of IDs of peers the node is connected to."},{"ref":"Libp2p.PubSub.html#publish/2","title":"Libp2p.PubSub.publish/2","type":"function","doc":"Clients can issue a PUBLISH request to publish data under a topic."},{"ref":"Libp2p.PubSub.html#subscribe/1","title":"Libp2p.PubSub.subscribe/1","type":"function","doc":"Clients can issue a SUBSCRIBE request to subscribe to a certain topic."},{"ref":"Libp2p.Serialize.html","title":"Libp2p.Serialize","type":"module","doc":""},{"ref":"Libp2p.Serialize.html#serialize/1","title":"Libp2p.Serialize.serialize/1","type":"function","doc":""}]